/**
 * Copyright (c) 2004-2015, Istvan David, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Istvan David - initial API and implementation
 */
package org.eclipse.viatra.cep.core.metamodels.trace;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.viatra.cep.core.metamodels.automaton.TimedZone;
import org.eclipse.viatra.cep.core.metamodels.automaton.Transition;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Timed Zone Trace</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace#getTimedZone <em>Timed Zone</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace#getTransition <em>Transition</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.cep.core.metamodels.trace.TracePackage#getTimedZoneTrace()
 * @model
 * @generated
 */
public interface TimedZoneTrace extends EObject {
	/**
	 * Returns the value of the '<em><b>Timed Zone</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Timed Zone</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Timed Zone</em>' reference.
	 * @see #setTimedZone(TimedZone)
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TracePackage#getTimedZoneTrace_TimedZone()
	 * @model required="true"
	 * @generated
	 */
	TimedZone getTimedZone();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace#getTimedZone <em>Timed Zone</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Timed Zone</em>' reference.
	 * @see #getTimedZone()
	 * @generated
	 */
	void setTimedZone(TimedZone value);

	/**
	 * Returns the value of the '<em><b>Transition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Transition</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Transition</em>' reference.
	 * @see #setTransition(Transition)
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TracePackage#getTimedZoneTrace_Transition()
	 * @model required="true"
	 * @generated
	 */
	Transition getTransition();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace#getTransition <em>Transition</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Transition</em>' reference.
	 * @see #getTransition()
	 * @generated
	 */
	void setTransition(Transition value);

} // TimedZoneTrace
