/**
 * Copyright (c) 2004-2015, Istvan David, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Istvan David - initial API and implementation
 */
package org.eclipse.viatra.cep.core.metamodels.trace;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.viatra.cep.core.metamodels.automaton.Automaton;

import org.eclipse.viatra.cep.core.metamodels.events.EventPattern;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Trace</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.trace.Trace#getEventPattern <em>Event Pattern</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.trace.Trace#getAutomaton <em>Automaton</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.cep.core.metamodels.trace.TracePackage#getTrace()
 * @model
 * @generated
 */
public interface Trace extends EObject {
	/**
	 * Returns the value of the '<em><b>Event Pattern</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Pattern</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Pattern</em>' reference.
	 * @see #setEventPattern(EventPattern)
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TracePackage#getTrace_EventPattern()
	 * @model required="true"
	 * @generated
	 */
	EventPattern getEventPattern();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.cep.core.metamodels.trace.Trace#getEventPattern <em>Event Pattern</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Pattern</em>' reference.
	 * @see #getEventPattern()
	 * @generated
	 */
	void setEventPattern(EventPattern value);

	/**
	 * Returns the value of the '<em><b>Automaton</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Automaton</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Automaton</em>' reference.
	 * @see #setAutomaton(Automaton)
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TracePackage#getTrace_Automaton()
	 * @model required="true"
	 * @generated
	 */
	Automaton getAutomaton();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.cep.core.metamodels.trace.Trace#getAutomaton <em>Automaton</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Automaton</em>' reference.
	 * @see #getAutomaton()
	 * @generated
	 */
	void setAutomaton(Automaton value);

} // Trace
