/**
 * Copyright (c) 2004-2015, Istvan David, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Istvan David - initial API and implementation
 */
package org.eclipse.viatra.cep.core.metamodels.trace;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.trace.TraceModel#getTraces <em>Traces</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.trace.TraceModel#getTimedZoneTraces <em>Timed Zone Traces</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.cep.core.metamodels.trace.TracePackage#getTraceModel()
 * @model
 * @generated
 */
public interface TraceModel extends EObject {
	/**
	 * Returns the value of the '<em><b>Traces</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra.cep.core.metamodels.trace.Trace}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Traces</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Traces</em>' containment reference list.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TracePackage#getTraceModel_Traces()
	 * @model containment="true"
	 * @generated
	 */
	EList<Trace> getTraces();

	/**
	 * Returns the value of the '<em><b>Timed Zone Traces</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.viatra.cep.core.metamodels.trace.TimedZoneTrace}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Timed Zone Traces</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Timed Zone Traces</em>' reference list.
	 * @see org.eclipse.viatra.cep.core.metamodels.trace.TracePackage#getTraceModel_TimedZoneTraces()
	 * @model
	 * @generated
	 */
	EList<TimedZoneTrace> getTimedZoneTraces();

} // TraceModel
