/**
 * Copyright (c) 2004-2015, Istvan David, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Istvan David - initial API and implementation
 */
package org.eclipse.viatra.cep.core.metamodels.trace.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.viatra.cep.core.metamodels.automaton.Automaton;

import org.eclipse.viatra.cep.core.metamodels.events.EventPattern;

import org.eclipse.viatra.cep.core.metamodels.trace.Trace;
import org.eclipse.viatra.cep.core.metamodels.trace.TracePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Trace</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceImpl#getEventPattern <em>Event Pattern</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.trace.impl.TraceImpl#getAutomaton <em>Automaton</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TraceImpl extends MinimalEObjectImpl.Container implements Trace {
	/**
	 * The cached value of the '{@link #getEventPattern() <em>Event Pattern</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventPattern()
	 * @generated
	 * @ordered
	 */
	protected EventPattern eventPattern;

	/**
	 * The cached value of the '{@link #getAutomaton() <em>Automaton</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAutomaton()
	 * @generated
	 * @ordered
	 */
	protected Automaton automaton;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TraceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TracePackage.Literals.TRACE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventPattern getEventPattern() {
		if (eventPattern != null && eventPattern.eIsProxy()) {
			InternalEObject oldEventPattern = (InternalEObject)eventPattern;
			eventPattern = (EventPattern)eResolveProxy(oldEventPattern);
			if (eventPattern != oldEventPattern) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TracePackage.TRACE__EVENT_PATTERN, oldEventPattern, eventPattern));
			}
		}
		return eventPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventPattern basicGetEventPattern() {
		return eventPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventPattern(EventPattern newEventPattern) {
		EventPattern oldEventPattern = eventPattern;
		eventPattern = newEventPattern;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRACE__EVENT_PATTERN, oldEventPattern, eventPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Automaton getAutomaton() {
		if (automaton != null && automaton.eIsProxy()) {
			InternalEObject oldAutomaton = (InternalEObject)automaton;
			automaton = (Automaton)eResolveProxy(oldAutomaton);
			if (automaton != oldAutomaton) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TracePackage.TRACE__AUTOMATON, oldAutomaton, automaton));
			}
		}
		return automaton;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Automaton basicGetAutomaton() {
		return automaton;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAutomaton(Automaton newAutomaton) {
		Automaton oldAutomaton = automaton;
		automaton = newAutomaton;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRACE__AUTOMATON, oldAutomaton, automaton));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TracePackage.TRACE__EVENT_PATTERN:
				if (resolve) return getEventPattern();
				return basicGetEventPattern();
			case TracePackage.TRACE__AUTOMATON:
				if (resolve) return getAutomaton();
				return basicGetAutomaton();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TracePackage.TRACE__EVENT_PATTERN:
				setEventPattern((EventPattern)newValue);
				return;
			case TracePackage.TRACE__AUTOMATON:
				setAutomaton((Automaton)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TracePackage.TRACE__EVENT_PATTERN:
				setEventPattern((EventPattern)null);
				return;
			case TracePackage.TRACE__AUTOMATON:
				setAutomaton((Automaton)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TracePackage.TRACE__EVENT_PATTERN:
				return eventPattern != null;
			case TracePackage.TRACE__AUTOMATON:
				return automaton != null;
		}
		return super.eIsSet(featureID);
	}

} //TraceImpl
