/**
 * Generated from file:/jobs/genie.viatra/viatra-master/workspace/query/plugins/org.eclipse.viatra.query.tooling.ui.retevis/src/org/eclipse/viatra/query/tooling/ui/retevis/ReteVisualization.vql
 */
package org.eclipse.viatra.query.tooling.ui.retevis;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import org.apache.log4j.Logger;
import org.eclipse.viatra.query.runtime.api.IMatchProcessor;
import org.eclipse.viatra.query.runtime.api.IQuerySpecification;
import org.eclipse.viatra.query.runtime.api.ViatraQueryEngine;
import org.eclipse.viatra.query.runtime.api.impl.BaseMatcher;
import org.eclipse.viatra.query.runtime.exception.ViatraQueryException;
import org.eclipse.viatra.query.runtime.matchers.tuple.Tuple;
import org.eclipse.viatra.query.runtime.rete.recipes.CheckRecipe;
import org.eclipse.viatra.query.runtime.util.ViatraQueryLoggingUtil;
import org.eclipse.viatra.query.tooling.ui.retevis.CheckRecipeMatch;
import org.eclipse.viatra.query.tooling.ui.retevis.util.CheckRecipeQuerySpecification;

/**
 * Generated pattern matcher API of the org.eclipse.viatra.query.tooling.ui.retevis.checkRecipe pattern,
 * providing pattern-specific query methods.
 * 
 * <p>Use the pattern matcher on a given model via {@link #on(ViatraQueryEngine)},
 * e.g. in conjunction with {@link ViatraQueryEngine#on(Notifier)}.
 * 
 * <p>Matches of the pattern will be represented as {@link CheckRecipeMatch}.
 * 
 * <p>Original source:
 * <code><pre>
 * {@literal @}Item(item = recipe, label = "Check (cache=$cache$)")
 * {@literal @}QueryExplorer(checked = false)
 * pattern checkRecipe(recipe : CheckRecipe, cache: java Boolean) {
 * 	CheckRecipe.cacheOutput(recipe, cache);
 * }
 * </pre></code>
 * 
 * @see CheckRecipeMatch
 * @see CheckRecipeProcessor
 * @see CheckRecipeQuerySpecification
 * 
 */
@SuppressWarnings("all")
public class CheckRecipeMatcher extends BaseMatcher<CheckRecipeMatch> {
  /**
   * Initializes the pattern matcher within an existing VIATRA Query engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing VIATRA Query engine in which this matcher will be created.
   * @throws ViatraQueryException if an error occurs during pattern matcher creation
   * 
   */
  public static CheckRecipeMatcher on(final ViatraQueryEngine engine) throws ViatraQueryException {
    // check if matcher already exists
    CheckRecipeMatcher matcher = engine.getExistingMatcher(querySpecification());
    if (matcher == null) {
        matcher = (CheckRecipeMatcher)engine.getMatcher(querySpecification());
    }
    return matcher;
  }
  
  /**
   * @throws ViatraQueryException if an error occurs during pattern matcher creation
   * @return an initialized matcher
   * @noreference This method is for internal matcher initialization by the framework, do not call it manually.
   * 
   */
  public static CheckRecipeMatcher create() throws ViatraQueryException {
    return new CheckRecipeMatcher();
  }
  
  private final static int POSITION_RECIPE = 0;
  
  private final static int POSITION_CACHE = 1;
  
  private final static Logger LOGGER = ViatraQueryLoggingUtil.getLogger(CheckRecipeMatcher.class);
  
  /**
   * Initializes the pattern matcher within an existing VIATRA Query engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing VIATRA Query engine in which this matcher will be created.
   * @throws ViatraQueryException if an error occurs during pattern matcher creation
   * 
   */
  private CheckRecipeMatcher() throws ViatraQueryException {
    super(querySpecification());
  }
  
  /**
   * Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param pCache the fixed value of pattern parameter cache, or null if not bound.
   * @return matches represented as a CheckRecipeMatch object.
   * 
   */
  public Collection<CheckRecipeMatch> getAllMatches(final CheckRecipe pRecipe, final Boolean pCache) {
    return rawGetAllMatches(new Object[]{pRecipe, pCache});
  }
  
  /**
   * Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param pCache the fixed value of pattern parameter cache, or null if not bound.
   * @return a match represented as a CheckRecipeMatch object, or null if no match is found.
   * 
   */
  public CheckRecipeMatch getOneArbitraryMatch(final CheckRecipe pRecipe, final Boolean pCache) {
    return rawGetOneArbitraryMatch(new Object[]{pRecipe, pCache});
  }
  
  /**
   * Indicates whether the given combination of specified pattern parameters constitute a valid pattern match,
   * under any possible substitution of the unspecified parameters (if any).
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param pCache the fixed value of pattern parameter cache, or null if not bound.
   * @return true if the input is a valid (partial) match of the pattern.
   * 
   */
  public boolean hasMatch(final CheckRecipe pRecipe, final Boolean pCache) {
    return rawHasMatch(new Object[]{pRecipe, pCache});
  }
  
  /**
   * Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param pCache the fixed value of pattern parameter cache, or null if not bound.
   * @return the number of pattern matches found.
   * 
   */
  public int countMatches(final CheckRecipe pRecipe, final Boolean pCache) {
    return rawCountMatches(new Object[]{pRecipe, pCache});
  }
  
  /**
   * Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param pCache the fixed value of pattern parameter cache, or null if not bound.
   * @param processor the action that will process each pattern match.
   * 
   */
  public void forEachMatch(final CheckRecipe pRecipe, final Boolean pCache, final IMatchProcessor<? super CheckRecipeMatch> processor) {
    rawForEachMatch(new Object[]{pRecipe, pCache}, processor);
  }
  
  /**
   * Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param pCache the fixed value of pattern parameter cache, or null if not bound.
   * @param processor the action that will process the selected match.
   * @return true if the pattern has at least one match with the given parameter values, false if the processor was not invoked
   * 
   */
  public boolean forOneArbitraryMatch(final CheckRecipe pRecipe, final Boolean pCache, final IMatchProcessor<? super CheckRecipeMatch> processor) {
    return rawForOneArbitraryMatch(new Object[]{pRecipe, pCache}, processor);
  }
  
  /**
   * Returns a new (partial) match.
   * This can be used e.g. to call the matcher with a partial match.
   * <p>The returned match will be immutable. Use {@link #newEmptyMatch()} to obtain a mutable match object.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param pCache the fixed value of pattern parameter cache, or null if not bound.
   * @return the (partial) match object.
   * 
   */
  public CheckRecipeMatch newMatch(final CheckRecipe pRecipe, final Boolean pCache) {
    return CheckRecipeMatch.newMatch(pRecipe, pCache);
  }
  
  /**
   * Retrieve the set of values that occur in matches for recipe.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  protected Set<CheckRecipe> rawAccumulateAllValuesOfrecipe(final Object[] parameters) {
    Set<CheckRecipe> results = new HashSet<CheckRecipe>();
    rawAccumulateAllValues(POSITION_RECIPE, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for recipe.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  public Set<CheckRecipe> getAllValuesOfrecipe() {
    return rawAccumulateAllValuesOfrecipe(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for recipe.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  public Set<CheckRecipe> getAllValuesOfrecipe(final CheckRecipeMatch partialMatch) {
    return rawAccumulateAllValuesOfrecipe(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for recipe.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  public Set<CheckRecipe> getAllValuesOfrecipe(final Boolean pCache) {
    return rawAccumulateAllValuesOfrecipe(new Object[]{
    null, 
    pCache
    });
  }
  
  /**
   * Retrieve the set of values that occur in matches for cache.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  protected Set<Boolean> rawAccumulateAllValuesOfcache(final Object[] parameters) {
    Set<Boolean> results = new HashSet<Boolean>();
    rawAccumulateAllValues(POSITION_CACHE, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for cache.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  public Set<Boolean> getAllValuesOfcache() {
    return rawAccumulateAllValuesOfcache(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for cache.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  public Set<Boolean> getAllValuesOfcache(final CheckRecipeMatch partialMatch) {
    return rawAccumulateAllValuesOfcache(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for cache.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  public Set<Boolean> getAllValuesOfcache(final CheckRecipe pRecipe) {
    return rawAccumulateAllValuesOfcache(new Object[]{
    pRecipe, 
    null
    });
  }
  
  @Override
  protected CheckRecipeMatch tupleToMatch(final Tuple t) {
    try {
        return CheckRecipeMatch.newMatch((CheckRecipe) t.get(POSITION_RECIPE), (Boolean) t.get(POSITION_CACHE));
    } catch(ClassCastException e) {
        LOGGER.error("Element(s) in tuple not properly typed!",e);
        return null;
    }
  }
  
  @Override
  protected CheckRecipeMatch arrayToMatch(final Object[] match) {
    try {
        return CheckRecipeMatch.newMatch((CheckRecipe) match[POSITION_RECIPE], (Boolean) match[POSITION_CACHE]);
    } catch(ClassCastException e) {
        LOGGER.error("Element(s) in array not properly typed!",e);
        return null;
    }
  }
  
  @Override
  protected CheckRecipeMatch arrayToMatchMutable(final Object[] match) {
    try {
        return CheckRecipeMatch.newMutableMatch((CheckRecipe) match[POSITION_RECIPE], (Boolean) match[POSITION_CACHE]);
    } catch(ClassCastException e) {
        LOGGER.error("Element(s) in array not properly typed!",e);
        return null;
    }
  }
  
  /**
   * @return the singleton instance of the query specification of this pattern
   * @throws ViatraQueryException if the pattern definition could not be loaded
   * 
   */
  public static IQuerySpecification<CheckRecipeMatcher> querySpecification() throws ViatraQueryException {
    return CheckRecipeQuerySpecification.instance();
  }
}
