/**
 * Generated from file:/jobs/genie.viatra/viatra-master/workspace/query/plugins/org.eclipse.viatra.query.tooling.ui.retevis/src/org/eclipse/viatra/query/tooling/ui/retevis/ReteVisualization.vql
 */
package org.eclipse.viatra.query.tooling.ui.retevis;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import org.apache.log4j.Logger;
import org.eclipse.viatra.query.runtime.api.IMatchProcessor;
import org.eclipse.viatra.query.runtime.api.IQuerySpecification;
import org.eclipse.viatra.query.runtime.api.ViatraQueryEngine;
import org.eclipse.viatra.query.runtime.api.impl.BaseMatcher;
import org.eclipse.viatra.query.runtime.exception.ViatraQueryException;
import org.eclipse.viatra.query.runtime.matchers.tuple.Tuple;
import org.eclipse.viatra.query.runtime.rete.recipes.TransitiveClosureRecipe;
import org.eclipse.viatra.query.runtime.util.ViatraQueryLoggingUtil;
import org.eclipse.viatra.query.tooling.ui.retevis.TransitiveClosureRecipeMatch;
import org.eclipse.viatra.query.tooling.ui.retevis.util.TransitiveClosureRecipeQuerySpecification;

/**
 * Generated pattern matcher API of the org.eclipse.viatra.query.tooling.ui.retevis.transitiveClosureRecipe pattern,
 * providing pattern-specific query methods.
 * 
 * <p>Use the pattern matcher on a given model via {@link #on(ViatraQueryEngine)},
 * e.g. in conjunction with {@link ViatraQueryEngine#on(Notifier)}.
 * 
 * <p>Matches of the pattern will be represented as {@link TransitiveClosureRecipeMatch}.
 * 
 * <p>Original source:
 * <code><pre>
 * {@literal @}Item(item = recipe, label = "Transitive Closure")
 * {@literal @}QueryExplorer(checked = false)
 * pattern transitiveClosureRecipe(recipe : TransitiveClosureRecipe) {
 * 	TransitiveClosureRecipe(recipe);
 * }
 * </pre></code>
 * 
 * @see TransitiveClosureRecipeMatch
 * @see TransitiveClosureRecipeProcessor
 * @see TransitiveClosureRecipeQuerySpecification
 * 
 */
@SuppressWarnings("all")
public class TransitiveClosureRecipeMatcher extends BaseMatcher<TransitiveClosureRecipeMatch> {
  /**
   * Initializes the pattern matcher within an existing VIATRA Query engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing VIATRA Query engine in which this matcher will be created.
   * @throws ViatraQueryException if an error occurs during pattern matcher creation
   * 
   */
  public static TransitiveClosureRecipeMatcher on(final ViatraQueryEngine engine) throws ViatraQueryException {
    // check if matcher already exists
    TransitiveClosureRecipeMatcher matcher = engine.getExistingMatcher(querySpecification());
    if (matcher == null) {
        matcher = (TransitiveClosureRecipeMatcher)engine.getMatcher(querySpecification());
    }
    return matcher;
  }
  
  /**
   * @throws ViatraQueryException if an error occurs during pattern matcher creation
   * @return an initialized matcher
   * @noreference This method is for internal matcher initialization by the framework, do not call it manually.
   * 
   */
  public static TransitiveClosureRecipeMatcher create() throws ViatraQueryException {
    return new TransitiveClosureRecipeMatcher();
  }
  
  private final static int POSITION_RECIPE = 0;
  
  private final static Logger LOGGER = ViatraQueryLoggingUtil.getLogger(TransitiveClosureRecipeMatcher.class);
  
  /**
   * Initializes the pattern matcher within an existing VIATRA Query engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing VIATRA Query engine in which this matcher will be created.
   * @throws ViatraQueryException if an error occurs during pattern matcher creation
   * 
   */
  private TransitiveClosureRecipeMatcher() throws ViatraQueryException {
    super(querySpecification());
  }
  
  /**
   * Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return matches represented as a TransitiveClosureRecipeMatch object.
   * 
   */
  public Collection<TransitiveClosureRecipeMatch> getAllMatches(final TransitiveClosureRecipe pRecipe) {
    return rawGetAllMatches(new Object[]{pRecipe});
  }
  
  /**
   * Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return a match represented as a TransitiveClosureRecipeMatch object, or null if no match is found.
   * 
   */
  public TransitiveClosureRecipeMatch getOneArbitraryMatch(final TransitiveClosureRecipe pRecipe) {
    return rawGetOneArbitraryMatch(new Object[]{pRecipe});
  }
  
  /**
   * Indicates whether the given combination of specified pattern parameters constitute a valid pattern match,
   * under any possible substitution of the unspecified parameters (if any).
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return true if the input is a valid (partial) match of the pattern.
   * 
   */
  public boolean hasMatch(final TransitiveClosureRecipe pRecipe) {
    return rawHasMatch(new Object[]{pRecipe});
  }
  
  /**
   * Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return the number of pattern matches found.
   * 
   */
  public int countMatches(final TransitiveClosureRecipe pRecipe) {
    return rawCountMatches(new Object[]{pRecipe});
  }
  
  /**
   * Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param processor the action that will process each pattern match.
   * 
   */
  public void forEachMatch(final TransitiveClosureRecipe pRecipe, final IMatchProcessor<? super TransitiveClosureRecipeMatch> processor) {
    rawForEachMatch(new Object[]{pRecipe}, processor);
  }
  
  /**
   * Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param processor the action that will process the selected match.
   * @return true if the pattern has at least one match with the given parameter values, false if the processor was not invoked
   * 
   */
  public boolean forOneArbitraryMatch(final TransitiveClosureRecipe pRecipe, final IMatchProcessor<? super TransitiveClosureRecipeMatch> processor) {
    return rawForOneArbitraryMatch(new Object[]{pRecipe}, processor);
  }
  
  /**
   * Returns a new (partial) match.
   * This can be used e.g. to call the matcher with a partial match.
   * <p>The returned match will be immutable. Use {@link #newEmptyMatch()} to obtain a mutable match object.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return the (partial) match object.
   * 
   */
  public TransitiveClosureRecipeMatch newMatch(final TransitiveClosureRecipe pRecipe) {
    return TransitiveClosureRecipeMatch.newMatch(pRecipe);
  }
  
  /**
   * Retrieve the set of values that occur in matches for recipe.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  protected Set<TransitiveClosureRecipe> rawAccumulateAllValuesOfrecipe(final Object[] parameters) {
    Set<TransitiveClosureRecipe> results = new HashSet<TransitiveClosureRecipe>();
    rawAccumulateAllValues(POSITION_RECIPE, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for recipe.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  public Set<TransitiveClosureRecipe> getAllValuesOfrecipe() {
    return rawAccumulateAllValuesOfrecipe(emptyArray());
  }
  
  @Override
  protected TransitiveClosureRecipeMatch tupleToMatch(final Tuple t) {
    try {
        return TransitiveClosureRecipeMatch.newMatch((TransitiveClosureRecipe) t.get(POSITION_RECIPE));
    } catch(ClassCastException e) {
        LOGGER.error("Element(s) in tuple not properly typed!",e);
        return null;
    }
  }
  
  @Override
  protected TransitiveClosureRecipeMatch arrayToMatch(final Object[] match) {
    try {
        return TransitiveClosureRecipeMatch.newMatch((TransitiveClosureRecipe) match[POSITION_RECIPE]);
    } catch(ClassCastException e) {
        LOGGER.error("Element(s) in array not properly typed!",e);
        return null;
    }
  }
  
  @Override
  protected TransitiveClosureRecipeMatch arrayToMatchMutable(final Object[] match) {
    try {
        return TransitiveClosureRecipeMatch.newMutableMatch((TransitiveClosureRecipe) match[POSITION_RECIPE]);
    } catch(ClassCastException e) {
        LOGGER.error("Element(s) in array not properly typed!",e);
        return null;
    }
  }
  
  /**
   * @return the singleton instance of the query specification of this pattern
   * @throws ViatraQueryException if the pattern definition could not be loaded
   * 
   */
  public static IQuerySpecification<TransitiveClosureRecipeMatcher> querySpecification() throws ViatraQueryException {
    return TransitiveClosureRecipeQuerySpecification.instance();
  }
}
