/**
 * Generated from file:/jobs/genie.viatra/viatra-master/workspace/query/plugins/org.eclipse.viatra.query.tooling.ui.retevis/src/org/eclipse/viatra/query/tooling/ui/retevis/ReteVisualization.vql
 */
package org.eclipse.viatra.query.tooling.ui.retevis;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import org.apache.log4j.Logger;
import org.eclipse.viatra.query.runtime.api.IMatchProcessor;
import org.eclipse.viatra.query.runtime.api.IQuerySpecification;
import org.eclipse.viatra.query.runtime.api.ViatraQueryEngine;
import org.eclipse.viatra.query.runtime.api.impl.BaseMatcher;
import org.eclipse.viatra.query.runtime.exception.ViatraQueryException;
import org.eclipse.viatra.query.runtime.matchers.tuple.Tuple;
import org.eclipse.viatra.query.runtime.rete.recipes.TransparentRecipe;
import org.eclipse.viatra.query.runtime.util.ViatraQueryLoggingUtil;
import org.eclipse.viatra.query.tooling.ui.retevis.TransparentRecipeMatch;
import org.eclipse.viatra.query.tooling.ui.retevis.util.TransparentRecipeQuerySpecification;

/**
 * Generated pattern matcher API of the org.eclipse.viatra.query.tooling.ui.retevis.transparentRecipe pattern,
 * providing pattern-specific query methods.
 * 
 * <p>Use the pattern matcher on a given model via {@link #on(ViatraQueryEngine)},
 * e.g. in conjunction with {@link ViatraQueryEngine#on(Notifier)}.
 * 
 * <p>Matches of the pattern will be represented as {@link TransparentRecipeMatch}.
 * 
 * <p>Original source:
 * <code><pre>
 * {@literal @}Item(item = recipe, label = "Transparent")
 * {@literal @}QueryExplorer(checked = false)
 * pattern transparentRecipe(recipe : TransparentRecipe) {
 * 	TransparentRecipe(recipe);
 * }
 * </pre></code>
 * 
 * @see TransparentRecipeMatch
 * @see TransparentRecipeProcessor
 * @see TransparentRecipeQuerySpecification
 * 
 */
@SuppressWarnings("all")
public class TransparentRecipeMatcher extends BaseMatcher<TransparentRecipeMatch> {
  /**
   * Initializes the pattern matcher within an existing VIATRA Query engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing VIATRA Query engine in which this matcher will be created.
   * @throws ViatraQueryException if an error occurs during pattern matcher creation
   * 
   */
  public static TransparentRecipeMatcher on(final ViatraQueryEngine engine) throws ViatraQueryException {
    // check if matcher already exists
    TransparentRecipeMatcher matcher = engine.getExistingMatcher(querySpecification());
    if (matcher == null) {
        matcher = (TransparentRecipeMatcher)engine.getMatcher(querySpecification());
    }
    return matcher;
  }
  
  /**
   * @throws ViatraQueryException if an error occurs during pattern matcher creation
   * @return an initialized matcher
   * @noreference This method is for internal matcher initialization by the framework, do not call it manually.
   * 
   */
  public static TransparentRecipeMatcher create() throws ViatraQueryException {
    return new TransparentRecipeMatcher();
  }
  
  private final static int POSITION_RECIPE = 0;
  
  private final static Logger LOGGER = ViatraQueryLoggingUtil.getLogger(TransparentRecipeMatcher.class);
  
  /**
   * Initializes the pattern matcher within an existing VIATRA Query engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing VIATRA Query engine in which this matcher will be created.
   * @throws ViatraQueryException if an error occurs during pattern matcher creation
   * 
   */
  private TransparentRecipeMatcher() throws ViatraQueryException {
    super(querySpecification());
  }
  
  /**
   * Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return matches represented as a TransparentRecipeMatch object.
   * 
   */
  public Collection<TransparentRecipeMatch> getAllMatches(final TransparentRecipe pRecipe) {
    return rawGetAllMatches(new Object[]{pRecipe});
  }
  
  /**
   * Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return a match represented as a TransparentRecipeMatch object, or null if no match is found.
   * 
   */
  public TransparentRecipeMatch getOneArbitraryMatch(final TransparentRecipe pRecipe) {
    return rawGetOneArbitraryMatch(new Object[]{pRecipe});
  }
  
  /**
   * Indicates whether the given combination of specified pattern parameters constitute a valid pattern match,
   * under any possible substitution of the unspecified parameters (if any).
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return true if the input is a valid (partial) match of the pattern.
   * 
   */
  public boolean hasMatch(final TransparentRecipe pRecipe) {
    return rawHasMatch(new Object[]{pRecipe});
  }
  
  /**
   * Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return the number of pattern matches found.
   * 
   */
  public int countMatches(final TransparentRecipe pRecipe) {
    return rawCountMatches(new Object[]{pRecipe});
  }
  
  /**
   * Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param processor the action that will process each pattern match.
   * 
   */
  public void forEachMatch(final TransparentRecipe pRecipe, final IMatchProcessor<? super TransparentRecipeMatch> processor) {
    rawForEachMatch(new Object[]{pRecipe}, processor);
  }
  
  /**
   * Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @param processor the action that will process the selected match.
   * @return true if the pattern has at least one match with the given parameter values, false if the processor was not invoked
   * 
   */
  public boolean forOneArbitraryMatch(final TransparentRecipe pRecipe, final IMatchProcessor<? super TransparentRecipeMatch> processor) {
    return rawForOneArbitraryMatch(new Object[]{pRecipe}, processor);
  }
  
  /**
   * Returns a new (partial) match.
   * This can be used e.g. to call the matcher with a partial match.
   * <p>The returned match will be immutable. Use {@link #newEmptyMatch()} to obtain a mutable match object.
   * @param pRecipe the fixed value of pattern parameter recipe, or null if not bound.
   * @return the (partial) match object.
   * 
   */
  public TransparentRecipeMatch newMatch(final TransparentRecipe pRecipe) {
    return TransparentRecipeMatch.newMatch(pRecipe);
  }
  
  /**
   * Retrieve the set of values that occur in matches for recipe.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  protected Set<TransparentRecipe> rawAccumulateAllValuesOfrecipe(final Object[] parameters) {
    Set<TransparentRecipe> results = new HashSet<TransparentRecipe>();
    rawAccumulateAllValues(POSITION_RECIPE, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for recipe.
   * @return the Set of all values or empty set if there are no matches
   * 
   */
  public Set<TransparentRecipe> getAllValuesOfrecipe() {
    return rawAccumulateAllValuesOfrecipe(emptyArray());
  }
  
  @Override
  protected TransparentRecipeMatch tupleToMatch(final Tuple t) {
    try {
        return TransparentRecipeMatch.newMatch((TransparentRecipe) t.get(POSITION_RECIPE));
    } catch(ClassCastException e) {
        LOGGER.error("Element(s) in tuple not properly typed!",e);
        return null;
    }
  }
  
  @Override
  protected TransparentRecipeMatch arrayToMatch(final Object[] match) {
    try {
        return TransparentRecipeMatch.newMatch((TransparentRecipe) match[POSITION_RECIPE]);
    } catch(ClassCastException e) {
        LOGGER.error("Element(s) in array not properly typed!",e);
        return null;
    }
  }
  
  @Override
  protected TransparentRecipeMatch arrayToMatchMutable(final Object[] match) {
    try {
        return TransparentRecipeMatch.newMutableMatch((TransparentRecipe) match[POSITION_RECIPE]);
    } catch(ClassCastException e) {
        LOGGER.error("Element(s) in array not properly typed!",e);
        return null;
    }
  }
  
  /**
   * @return the singleton instance of the query specification of this pattern
   * @throws ViatraQueryException if the pattern definition could not be loaded
   * 
   */
  public static IQuerySpecification<TransparentRecipeMatcher> querySpecification() throws ViatraQueryException {
    return TransparentRecipeQuerySpecification.instance();
  }
}
